<script lang="ts" setup>

    import {useAuthStore} from "../stores/useAuthStore";
    import { createToaster } from "@meforma/vue-toaster";
    import {useErrorStore} from "../stores/useErrorStore";
    import {onMounted} from "../.nuxt/imports";
    import {useLoadingStore} from "../stores/useLoadingStore";

    const auth = useAuthStore()

    const errorStore = useErrorStore()

    async function handleLogout(){
        await auth.logout()
    }

    // @todo I don't know why, but if we change the URL in the browser to access another page, we are not logged in. (server-side)

    const toaster = createToaster({ /* options */ });

    watch(() => errorStore.error, (newMessage, oldMessage) => {
        if(newMessage !== oldMessage){
            showError(newMessage)
        }
    });

    function showError(error){
        if (error) {
            toaster.error(error, { duration: 30000 });
            errorStore.clearError();
        }
    }

    onMounted(() => {
        showError(errorStore.error)
    })

    //

    const loader = useLoadingStore();

    const loading = computed(() => { return loader.isLoading})
</script>

<template>
  <div v-if="loading">
    <div class="loading w-full h-full fixed flex items-center justify-center bg-green-500">
      Loading
    </div>
  </div>
  <div>
    <nav class="p-4 bg-green-500">
      <div class="container mx-auto flex items-center justify-between">
        <ul class="flex items-center">
          <li>
            <NuxtLink to="/">
              Home
            </NuxtLink>
          </li>
          <li
            v-if="!auth.isLoggedIn"
            class="ml-4"
          >
            <NuxtLink to="/login">
              Login
            </NuxtLink>
          </li>
          <li
            v-if="auth.isLoggedIn"
            class="ml-4"
          >
            <NuxtLink to="/admin">
              Admin
            </NuxtLink>
          </li>
        </ul>
        <button
          v-if="auth.isLoggedIn"
          title="Log out"
          @click="handleLogout"
        >
          <svg
            xmlns="http://www.w3.org/2000/svg"
            fill="none"
            viewBox="0 0 24 24"
            stroke-width="1.5"
            stroke="currentColor"
            class="w-6 h-6"
          >
            <path
              stroke-linecap="round"
              stroke-linejoin="round"
              d="M15.75 9V5.25A2.25 2.25 0 0 0 13.5 3h-6a2.25 2.25 0 0 0-2.25 2.25v13.5A2.25 2.25 0 0 0 7.5 21h6a2.25 2.25 0 0 0 2.25-2.25V15m3 0 3-3m0 0-3-3m3 3H9"
            />
          </svg>
        </button>
      </div>
    </nav>
    <div class="container mx-auto mt-4">
      <slot />
    </div>
  </div>
</template>

<style lang="scss">
    .button{
        background: rgb(34 197 94 / 1);
        border-radius: 5px;
        padding: 0.5rem;
        color: white;
        cursor: pointer;
        &.delete{
            background: rgb(220 38 38);
        }
        &.small{
            padding: 0.2rem;
        }
    }
</style>
